`timescale 1ns / 1ps
//******************************************************************************
// File Name            : i2c_ap_test.v
//------------------------------------------------------------------------------
// Function             : i2c sample application test
//                        
//------------------------------------------------------------------------------
// Designer             : yokomizo 
//------------------------------------------------------------------------------
// History
// -.-- 2010/10/09
//******************************************************************************
  
module i2c_ap_test;

        // Inputs
        reg clk;
        reg rstb;

        // Outputs
        wire led_0;
        //wire scl;
        tri1 scl;

        // Bidirs
        //wire sda;
        tri1 sda;

        //rs232c
        wire   txd;
        reg    rxd;
   

        reg [7:0] bit_cnt = 8'd0;
        reg       read_mode = 1'b1;
        reg       sda_drv = 1'bz;
        reg [7:0] end_bit;
        reg               scl_d1;
        reg               sda_d1;
         wire             scl_rise;
         wire             scl_fall;
   

       assign     sda = sda_drv;
   
   
        // Instantiate the Unit Under Test (UUT)
        i2c_ap uut (
                .clk(clk), 
                .rstb(rstb), 
                .led_0(led_0), 
                .scl(scl), 
                .sda(sda),
                .txd(txd),
                .rxd(rxd)
        );

        initial begin
                // Initialize Inputs
                clk = 0;
                rstb = 0;
                rxd = 1;
                // Wait 100 ns for global reset to finish
                #100;
                rstb = 1;
        
                // Add stimulus here

        end
  
        initial begin
                // Initialize Inputs
                clk = 0;
                repeat(50000000) begin
                #12.5;
                clk = 1;
                #12.5;
                clk = 0;
                end
                $stop;
        end // initial begin

        always@(posedge clk )
          begin
            scl_d1 <= scl;
            sda_d1 <= sda;
          end   

   assign scl_rise = ((scl==1'b1)&&(scl_d1==1'b0)) ;
   assign scl_fall = ((scl==1'b0)&&(scl_d1==1'b1)) ;
   
   
        always@(posedge clk or negedge rstb)
          if (rstb==1'b0)
            bit_cnt <= 8'd0;
          else if ((scl==1'b1)&&(sda==1'b1)&&(sda_d1==1'b0))
            bit_cnt <= 8'd0;
          else if (scl_rise==1'b1)
            bit_cnt <= bit_cnt +8'd1;
          else
            bit_cnt <= bit_cnt;

        always@(posedge clk )
          if(scl_rise==1'b1)
            if (bit_cnt==8'd7)
              if(sda==1'b1)
                read_mode <= 1'b1;
              else
                read_mode <= 1'b0;
            else
              read_mode <= read_mode;
          else
            read_mode <= read_mode;
   
        always@(posedge clk)
          if(scl_fall==1'b1)
            if (bit_cnt==8'd8)
               sda_drv <= 1'b0;
            else if (read_mode==1'b1)
              if (bit_cnt==8'd9)
                sda_drv <= 1'b1;
              else if (bit_cnt==8'd10)
                sda_drv <= 1'b0;
              else if (bit_cnt==8'd11)
                sda_drv <= 1'b1;
              else if (bit_cnt==8'd12)
                sda_drv <= 1'b0;
              else if (bit_cnt==8'd13)
                sda_drv <= 1'b1;
              else if (bit_cnt==8'd14)
                sda_drv <= 1'b1;
              else if (bit_cnt==8'd15)
                sda_drv <= 1'b0;
              else if (bit_cnt==8'd16)
                sda_drv <= 1'b0;
              else              
                sda_drv <= 1'bz;
            else
              if((bit_cnt==8'd17)||(bit_cnt==8'd26)||(bit_cnt==8'd35)||(bit_cnt==8'd44))
                sda_drv <= 1'b0;
              else
                sda_drv <= 1'bz;                
          else
            sda_drv <= sda_drv;

endmodule

